#ifndef __BRAUNPSD_H
#define __BRAUNPSD_H

class TBraun_Psd : public TPsd
{
  public:
    TBraun_Psd(  void );
    ~TBraun_Psd(  void );
    int Initialize(  void );
    //int PollDevice( void );
    int PsdInit(  void );
    int PsdStart(  void );
    int SetParameters(  void )
    { return R_OK; };
    int PsdReadOut(  THowReadOutPsd );
    int GetBufferSize(  void );
    void SetDataType(  TPsdDataType );
    int SetEnergyRange(  UINT, UINT );
    int GetEnergyRange(  UINT& ler, UINT& her )
    { her = uEnergyHigh; ler = uEnergyLow; return R_OK; };
    int PsdStop(  void );
    int nErrorCode;
    BOOL bSetError;
    int nHVRegelung_OK;
  protected:
    int BuildOperation(  BYTE*, BYTE*, int );
    int LoadHexFile(  void );
    void ResetDelayTime(  void );
    BYTE konvert(  char );
    int SynchronHexFile(  BYTE&, BYTE& );
    int Look_till_BaseAddr1(  int );
  private:
    TPsdDataType eDataType;
    typedef union
    {
      LONG LWert;
      WORD IWert[ 2 ];
      BYTE SWert[ 4 ];
    } long_to_bytes;
    struct MessDatenHeader
    {
      long HighADCCounts;
      long LowADCCounts;
      long HighEGYCounts;
      long LowEGYCounts;
      long HighPOSCounts;
      long LowPOSCounts;
      long HSumDetCounts;
      long LSumDetCounts;
      long RateADC;
      long RateEGY;
      long RatePOS;
      long RateDET;
      long Messzeit;
      long HVParameter;
      long EndLifeTime;
      long Ueberlauf;
    }
    Header;
    static BYTE echo[ 30 ][ 16 ];
    static BYTE befehl[ 30 ][ 16 ];
    char Buffer[ 16 ];
    UINT uMuxTimeDet1;
    LONG PositionsDatenHeader[ 16 ];
    UINT uEnergyScale; // moeglich sind 00, 01, 02, 03 hex
    UINT uPositionScale; // moeglich sind 00, 01, 02, 03 hex
    UINT uEnergyHigh;
    UINT uEnergyLow;
    LONG lPositionStop; // Countstop fuer Positionskanaele
    // 0..EFFFFFFFFFFF hex
    BOOL bDebugInfo; // boolscher Wert
    BOOL bAbbruchmitShutter; // boolscher Wert
    int nDeathTime; // min. Impulsabstand 0..99 dec [0..99 *E-6 sec]
    BOOL bRatemeter; // computed=00, total=01
    BOOL bRealLifeTime; // Realtime=00, Lifetime=01
    LONG lMeasTime; // Messzeit 1..9999999 dec [sec]
    HGLOBAL hReadBuf;
    int nDelayFast;
    int nDelaySlow;
    UINT uCBufferLength;
    int nReadBufItems;
};


#endif
// __BRAUNPSD_H
// __LastLine__