#ifndef _EVRYTHNG_H
#define _EVRYTHNG_H

// (C) 1993,1994 by Heiko Damerow MPG AG "Roentgenbeugung"
#define STRICT
#include <windows.h>
#include <string.h>
#include <windowsx.h>
#include <mmsystem.h>
#include <stdio.h>
#include <math.h>
#include <dos.h>
#include <dir.h>
#include <except.h>  // for xalloc exception class


#define    MaxString           80
#define    MBINFO              (MB_OK | MB_ICONINFORMATION)
#define    MBASK               (MB_YESNO | MB_ICONQUESTION)
#define    MBFAILURE           (MB_OK | MB_ICONHAND)
#define    MBSTOP              (MB_OK | MB_ICONSTOP)
#define    YES                 TRUE
#define    NO                  FALSE
#define    ON                  TRUE
#define    OFF                 FALSE
#define    W_DiffractionWindow 251
#define    W_PSDWindow         252
#define    W_CounterWindow     253
#define    W_EditWindow        254
#define    W_AdjustmentWindow  255

// Voreinstellungen
#define    LEFT                55
#define    RIGHT               56

#define   LenAdditionalInfo    40

/* Benutzt in m_arscan.cpp, m_scan.cpp */
#define EOL      "\r\n"
/* Benutzt in m_arscan.cpp, m_scan.cpp */
#define P_X      0
/* Benutzt in m_arscan.cpp, m_data.cpp */
#define P_Y      1
/* Benutzt in m_arscan.cpp */
#define P_Z      2

/* Benutzt in braunpsd.cpp, counters.cpp, m_arscan.cpp, m_main.cpp, m_scan.cpp,
    motors.cpp, testdev.cpp */
#define  R_Failure         202
/* Benutzt in counters.cpp */
#define  R_MeasInProcess   205
/* Benutzt in counters.cpp */
#define  R_MeasOk          206

/* Benutzt in motors.cpp */
#define  R_TimeOut         214
/* Benutzt in motors.cpp */
#define  R_UnknownCmd      215
/* Benutzt in counters.cpp */
#define  R_SoftOverflow    216
/* Benutzt in braunpsd.cpp, counters.cpp */
#define  R_HardOverflow    217
/* Benutzt in l_layer.cpp, m_scan.cpp */
#define  R_Overflow        218
/* Benutzt in l_layer.cpp, m_scan.cpp */
#define  R_EndOfFile       219

/* Benutzt in m_motcom.h, m_mothw.h, m_psd.h, braunpsd.cpp, counters.cpp,
    m_dlg.cpp, motors.cpp */
#define  R_OK              999

/* HPBYTE, HPFLOAT: Benutzt in m_data.cpp, m_device.cpp */
/* HPSTR: benutzt in m_arscan.cpp (Allerdings Verdacht auf toten Code) */
/* HPWORD: NICHT BENUTZT */
#if defined(__FLAT__)
 typedef char*  HPSTR;
 typedef BYTE*  HPBYTE;
 typedef float* HPFLOAT;
 typedef WORD*  HPWORD;
#else
 typedef char  _huge * HPSTR;
 typedef BYTE  _huge * HPBYTE;
 typedef float _huge * HPFLOAT;
 typedef WORD  _huge * HPWORD;
#endif



/* Benutzt in m_devcom.h, m_motcom.h, m_psd.h, l_layer.cpp, m_layer.h/cpp,
    m_arscan.cpp, counters.cpp */
typedef enum
{
  Grad = 1, Minuten, Sekunden, Millimeter, Mikrometer, Channel, None
} TUnitType;

/* Benutzt in m_arscan.cpp */
typedef struct
{
  int   h, k, l;
} THKL;

/* Benutzt in m_data.h/cpp, m_main.cpp */
typedef struct
{
  BOOL  bLogarithmicY;
  float fMinX, fMaxX, fMinY, fMaxY;
} TKSProperties;

// Benutzt in datavisa.h, swintrac.h, m_data.h
typedef enum
{
  Logarithmic = 1, Linear, User
} TScaleType;

// Benutzt in difrkmty.h, a_arscan.h, m_scan.h, l_layer.cpp, m_steerg.h/cpp 
typedef enum
{
  StandardScan = 1, Omega2ThetaScan, ContinuousScan, PsdEnergyScan,
      PsdPositionScan, Omega2ThetaScanList, ScanList
} TxScanType;

extern "C" {
LRESULT CALLBACK  _export WndProc( HWND, UINT, WPARAM, LPARAM );
LRESULT CALLBACK  _export FrameWndProc( HWND, UINT, WPARAM, LPARAM );
}

class __rtti TMDIWindow
{
  friend void    NewWindow( TMDIWindow* );
  friend LRESULT DoCommandsChild( TMDIWindow*, HWND, WPARAM, LPARAM );
  friend LRESULT CALLBACK FrameWndProc( HWND, UINT, WPARAM, LPARAM );
  friend LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
  friend LRESULT CALLBACK AdjustmentProc( HWND, UINT, WPARAM, LPARAM );
 public:
                  TMDIWindow( void );
  virtual         ~TMDIWindow( void );
  HWND            GetWndHandle( void )
      { return hWndChild; };
  virtual void    CalibratePsd( void )
      {};
  virtual void    ExternSychronized( void )
      {};
  virtual LRESULT CallLocalAction( WPARAM, LPARAM )
      { return 0l; };
  virtual void    MouseMove( WPARAM, LPARAM )
      {};
  virtual BOOL    SetTitle()
      { return TRUE; };
  virtual void    rButtonDown( LONG )
      {};
  virtual void    Paint( HDC, PAINTSTRUCT* )
      {};
  virtual void    RenderFormat( WPARAM )
      {};
  virtual void    RenderAllFormats( WPARAM )
      {};
  virtual void    SetFocus( void );
  virtual HCURSOR GetCursor( void )
      { return LoadCursor( NULL, IDC_ARROW ); };
  // Virtuelle Funktionen zum Abwickeln von Ablaeufen
  // call via messages
  virtual void    SteeringReady( LPARAM )
      {};
  virtual void    SetRanges( void )
      {};
  virtual void    CounterSetRequest( LPARAM )
      {};
  virtual void    DistanceSetRequest( LPARAM )
      {};
  virtual void  PickUpData( LPARAM )
      {};
  virtual void  SetKSProperties( TKSProperties* )
      {};
  // call via menu
  virtual void    InitializeTask( WPARAM, LPARAM )
      {};
  virtual void    InitializeDlg( WPARAM, LPARAM )
      {};
  virtual void    FreezeCurve( void )
      {};
  virtual void    KillSecondCurve( void )
      {};
  virtual void    SaveSecondCurve( void )
      {};
  BOOL            SetFileName( LPSTR );
  LPSTR           GetFileName( void )
      { return FileName; };
  // call via system
  virtual BOOL    SaveFile( int );
  virtual BOOL    New( void );
  virtual BOOL    SaveFileAs( void );
  virtual void    TimerRequest( WPARAM )
      {};
  virtual BOOL    LoadOldData( int )
      { return FALSE; };
  virtual BOOL    UpdateFile( void )
      { return FALSE; };
  virtual void    Create( HWND hwnd )
      { hWndChild = hwnd; };
  virtual void    Size( HWND, WPARAM, LPARAM )
      {};
  void            UpdateMenu( void );
  void            UpdateWnd( int act );
  BOOL            WholeWnd( void );
  char            szDataPath[MaxString];
 protected:
  virtual BOOL    CanClose( void );
  virtual LPCSTR  ClassName( void )
      { return "Nutzerfenster"; };
  virtual LPCSTR  GetCharacteristic( void )
      { return "Fenster"; };
  virtual void    lButtonDown( WPARAM, LPARAM )
      {};
  virtual void    DoCopy( void )
      {};
  virtual void    lButtonUp( WPARAM, LPARAM )
      {};
  virtual void    Interrupt( void );
  virtual BOOL    CanOpen( void );
  void            SetMenu( void );
  BOOL            IsModified( void )
      { return bFileChanged; };
  void            FileChange( void )
      { bFileChanged = TRUE; };
  WORD            RegisterWnd( void );
  void            GetWindowClass( WNDCLASS *wndClass );
  char            FileName[2*MaxString];
  char            szFilter[MaxString];
  char            szExtension[4];
  BOOL            bOldDataLoaded;
  BOOL            bIsNewFile;
  BOOL            bFileChanged;
  HWND            hWndChild;             // Fenster-Handle des  Arbeitsfensters
  char            Title[MaxString];           // headline
  char            FontName[MaxString];
  int             WindowType;
  RECT            WndRect;
  RECT            ClientRect;
  BOOL            bMeasurementActive;
  BOOL            bInterrupted;
  HMENU           TheMenu;                  // Lokales Menu des Fensters
 private:
  BOOL            bPaintPoint;
  static int      WindowId;                 // Fenster-Zaehler
};

typedef struct
{
  HWND      hWndFrame;
  HWND      hWndClient;
  HINSTANCE hInstance;
  UINT      wm_DrawStatus;
  BOOL      bCreateIniDefaults;
} TMainParameters;

class TFileLocations;

class TMain
{
 public:
                   TMain( void );
                   ~TMain( void );
  static int       MessageLoop( void );
  void             SetWatchIndicator( long );
  void             SetParameters( void );
  void             TellMessage( int );
  HMENU            LoadMenuBar( void );
  BOOL             GetVersion( LPSTR );
  TMainParameters* GetParameters( void )
      { return &Parameters; };
  void             LoadProfile( void );
  void             SaveProfile( void );
  void             BlastStatusLine( HWND, HDC, int );
  void             DrawStatus( HWND, ATOM, int );
  UINT             wm_DrawStatus;
  BOOL             GetDataDlg( LPSTR, int* );
  TMDIWindow*      CurrentWindow;
  TMDIWindow*      AdjustmentWindow;
  TMDIWindow*      ScanWindow;
  TMDIWindow*      CCDLineScanWindow;
  TMDIWindow*      AreaScanWindow;
  TMDIWindow*      AreaScanCCDWindow;
  HWND             hAdjustmentWindow;
  HWND             hCCDLineScanWindow;
  HWND             hScanWindow;
  HWND             hAreaScanWindow;
  HWND             hAreaScanCCDWindow;
  HWND             hActualWindow;
  int              nStartup;
  HMENU            hTheMenu;
  int              CurrentID;
  HMENU            CurrentPopup;
  char             StatusInfo[2*MaxString];
  char             AdditionalInfo[LenAdditionalInfo];
  char             Comment[2*MaxString];
  THKL             Reflection;
  THKL             Orientation;
  char             User[MaxString];
  char             Target[MaxString];
  char             TargetBulk[MaxString];
  float            WaveLength;
  BOOL             bAutoCalibration;
  BOOL             bCreateIniDefaults;
  int              Voltage;
  int              Current;
  HBITMAP          bmpStatusLine;
  TMainParameters  Parameters;
  static HWND      hWndFrame;
  static HWND      hWndClient;
  static HINSTANCE hInstance;
  static HINSTANCE hPrevInstance;
  static HACCEL    hAccellerator;
  static int       nCmdShow;
private:
  TFileLocations   *FileLocations;	
};


/* Benutzt in m_arscan.cpp, m_scan.cpp,
    m_steerg.cpp, m_main.cpp, m_device.cpp */
#define O_PaintPoint 0x0020
#define O_Flush      0x0040

/* Benutzt in counters.cpp, testdev.cpp */
#define DeviceTimerIdStart   100

/* Benutzt in m_arscan.cpp, m_dlg.cpp, m_topo.cpp, motors.cpp */
#define   TimerIdInformation 399

/* Benutzt in m_dlg.cpp, m_main.cpp, m_scan.cpp */
void GetHKL( THKL& refl, LPSTR info );
/* Benutzt in m_dlg.cpp, m_main.cpp, m_scan.cpp */
void SetHKL( THKL& refl, LPCSTR info );

///////////////////////////////////////////////////////////////////////
// ! neu Kullmann+Reinecker:           Auslesen von FileLocations 
// impl. in "l_layer.cpp"
///////////////////////////////////////////////////////////////////////

//erlaubt Uebernahme der Daten aus TMain::FileLocations nach "l_layer.cpp"
void WINAPI InitializeFileLocations(TFileLocations* fl);

//liefert FileLocations.GetDirectory
LPCSTR WINAPI GetDirectory( void );
//liefert FileLocations.GetName
LPCSTR WINAPI GetName( void );
 
//liefert FileLocations.GetHWFile
LPCSTR WINAPI GetHWFile( void );
//liefert FileLocations.GetCFile
LPCSTR WINAPI GetCFile( void );
//liefert FileLocations.GetTestDevFile
LPCSTR WINAPI GetTestDevFile( void );
//liefert FileLocations.GetMacroFile; <macroname> sollte auf ".mak" enden (z.B. "scan.mak" oder "standard.mak")
LPCSTR WINAPI GetMacroFile( LPCSTR macroname ); 

#ifdef __cplusplus
extern "C" {
#endif
void       WINAPI SetInfo( LPCSTR );
void       WINAPI SetStaticInfo( LPCSTR );
void       WINAPI SetStatus( LPCSTR );
BOOL       WINAPI FileOpen( LPCSTR, LPSTR, LPSTR, LPCSTR );
BOOL       WINAPI FileSave( LPCSTR, LPSTR, LPSTR, LPCSTR );
BOOL       WINAPI CreateDefaults( void );
int        WINAPI GetFileLine( int, LPSTR, int );
HWND       WINAPI GetFrameHandle( void );
HWND       WINAPI GetClientHandle( void );
HINSTANCE  WINAPI GetMainInstance( void );
TUnitType  WINAPI UnitEnum( LPSTR );
BOOL       WINAPI SetFPOnData( HFILE hfile );
void       WINAPI DelayTime( int );
void       WINAPI Delay( long );

#ifdef __cplusplus
}
#endif

#endif //ndef _EVRYTHNG_H
