#include "winresrc\rc_def.h"
#include "internls\evrythng.h"
#pragma hdrstop
// m_dlg.cpp
// (C) 1993,1994 by Heiko Damerow MPG AG "Rntgenbeugung"
// Definition verschiedener Dialog-Prozeduren

#include  "swintrac\swintrac.h"

#include  "datavisa\datavisa.h"
#include  "workflow\workflow.h"

#include "detecuse\detecuse.h"
#include "motrstrg\motrstrg.h"

#include "swintrac\m_dlg.h"


// variables related to continuous scan's
TCScanParam CScan;

//*** verschiedene Macros ******************************************************
extern TMain     Main;
extern TSteering Steering;
extern LPDList   lpDList;
extern BOOL      bManualMovesCorrected;

//******************************************************************************
TGetData::TGetData(LPSTR dt,int* dr) : TModalDlg("GetData")
{
  dataref = dr;
  strcpy(datatext,dt);
};

BOOL TGetData::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
{
  char buf[30];

  TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam);
  itoa(*dataref,buf,10);
  SetDlgItemText(hwnd,id_GetDataText,datatext);
  SetDlgItemText(hwnd,id_GetDataValue,buf);
  return TRUE;
};

BOOL TGetData::CanClose(void)
{
  char buf[30];

  GetDlgItemText(GetHandle(),id_GetDataValue,buf,29);
  *dataref = atoi(buf);
  return TRUE;
};


//***** Dialog fr die Einstellungen des Psd ***********************************
TPsdParameters::TPsdParameters() : TModelessDlg("PsdParameter")
{
};

#pragma argsused
BOOL TPsdParameters::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
{
  if(!lpDList->IsDeviceValid(PsdDevice))
  {
    FORWARD_WM_COMMAND(hwnd,IDCANCEL,hwndCtl,0,PostMessage);
    return FALSE;
  }
  Device = (TPsd*)lpDList->DP(lpDList->GetIdByName(PsdDevice));
  // Initialisieren der Parameterfenster
  EnableWindow(GetDlgItem(hwnd,id_StepWidth),FALSE);
  EnableWindow(GetDlgItem(hwnd,id_AngleRange),FALSE);

  FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
  SetFocus(GetDlgItem(hwnd,id_AddedChannels));
  return TRUE;
};

void TPsdParameters::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
{
  char buf[MaxString];
  UINT her,ler;

  switch(id) 
  {
    case cm_ParamSet:
    sprintf(buf,"%.2f",Device->GetAngleRange());
    SetDlgItemText(hwnd,id_AngleRange,(LPSTR)buf);
    sprintf(buf,"%d",Device->nAddedChannels);
    SetDlgItemText(hwnd,id_AddedChannels,(LPSTR)buf);
    sprintf(buf,"%.2f",Device->fAngleStep);
    SetDlgItemText(hwnd,id_StepWidth,(LPSTR)buf);
    Device->GetEnergyRange(ler,her);
    sprintf(buf,"%d",her);
    SetDlgItemText(hwnd,id_UpperLevel,(LPSTR)buf);
    sprintf(buf,"%d",ler);
    SetDlgItemText(hwnd,id_LowerLevel,(LPSTR)buf);
    sprintf(buf,"%d",Device->nMaxChannel);
    SetDlgItemText(hwnd,id_PositionMax,(LPSTR)buf);
    sprintf(buf,"%d",Device->nMinChannel);
    SetDlgItemText(hwnd,id_PositionMin,(LPSTR)buf);
    CheckDlgButton(hwnd,id_EnergyControl,Device->bHVRegelung);
    CheckDlgButton(hwnd,id_LeftConnectedZero,Device->bReadLeftFirst);
    break;

    case cm_InitializePsd:
    if(CanClose())
      if(R_OK != Device->PsdInit())
        SetInfo("Init Psd failed.");
    FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
    break;

    case cm_ClearEnergyData:
    MessageBox(GetFocus(),"Zur Zeit nicht untersttzt !","Message",MBINFO);
    break;

    case cm_SetEnergyRange:
    GetDlgItemText(hwnd,id_UpperLevel,buf,MaxString);
    her = atoi(buf);
    GetDlgItemText(hwnd,id_LowerLevel,buf,MaxString);
    ler = atoi(buf);
    if(R_OK != Device->SetEnergyRange(ler,her))
    {
       FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,PostMessage);
       SetInfo("SetEnergy Range failed.");
    }
    break;

    case cm_SetPositionRange:
    GetDlgItemText(hwnd,id_PositionMax,buf,MaxString);
    Device->nMaxChannel = atoi(buf);
    GetDlgItemText(hwnd,id_PositionMin,buf,MaxString);
    Device->nMinChannel = atoi(buf);
    break;

    default:
    TModelessDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
  }
};

BOOL TPsdParameters::CanClose(void)
{
  int val_i,store_i;
  int her,ler;
  BOOL bFailure = FALSE,id = 0;

  FORWARD_WM_COMMAND(GetHandle(),cm_SetPositionRange,0,0,SendMessage);
  Device->bHVRegelung = IsDlgButtonChecked(GetHandle(),id_EnergyControl);
  Device->bReadLeftFirst = IsDlgButtonChecked(GetHandle(),id_LeftConnectedZero);
  val_i = store_i = GetDlgItemInt(GetHandle(),id_AddedChannels,(LPINT)&id,FALSE);
  val_i = max(1,val_i);
  val_i = min((int)(0.1 * Device->GetChannelNumber()),val_i);
  if(store_i != val_i)
    bFailure &= TRUE;
  Device->SetAddedChannels(val_i);
  her = GetDlgItemInt(GetHandle(),id_UpperLevel,&her,FALSE);
  ler = GetDlgItemInt(GetHandle(),id_LowerLevel,&ler,FALSE);
  if(R_OK != Device->SetEnergyRange(ler,her))
    return FALSE;
  return TRUE;
};

BOOL TPsdParameters::LeaveDialog(void)
{
  return TRUE;
};

//********* Direkte Eingabe von Kommandos *******************
TExecuteCmd::TExecuteCmd():TModalDlg("ExecuteCmd")
{
  ExecutionId = 0;
};

BOOL TExecuteCmd::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
{
  TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam);
  nMotor = mlGetAxis();
  SetDlgItemText(hwnd,cm_RotateMotor,mGetAxisName());
  SetFocus(GetDlgItem(hwnd,id_CommandLine));
  return TRUE;
};

void TExecuteCmd::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
{
//! static int   i = 0;
  HWND hwndCmd = GetDlgItem(hwnd,id_Response);
  char cmd[MaxString+1];
  char *lpszToken;

  switch(id)
  {
    case IDOK:
    GetDlgItemText(hwnd,id_CommandLine,cmd,34);
    strcat(cmd,"\r");
    if(R_OK == mExecuteCmd(cmd))
    {
      lpszToken = strtok(cmd,"\n\3\r");
      while(lpszToken)
      {
        if(strlen(lpszToken) > 1)
          ComboBox_AddString(hwndCmd,lpszToken);
        lpszToken = strtok(NULL,"\n\3\r");
      }
    }
    break;

    case cm_RotateMotor:
    mlSetAxis(1+mlGetAxis());
    SetDlgItemText(hwnd,cm_RotateMotor,(LPSTR)mGetAxisName());
    SetFocus(GetDlgItem(hwnd,id_CommandLine));
    break;

    default:
    TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
  }
};

BOOL TExecuteCmd::LeaveDialog(void)
{
  return TRUE;
};

//******************************************************************************
//******************************************************************************
TMeasurementParam::TMeasurementParam() : TModalDlg("MeasurementParam")
{
};

BOOL TMeasurementParam::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
{
  char buf[MaxString];

  TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam);
  SetFocus(GetDlgItem(hwnd,IDOK));
  sprintf(buf,"%s",Main.Target);
  SetDlgItemText(hwnd,id_TargetName,buf);
  sprintf(buf,"%s",Main.TargetBulk);
  SetDlgItemText(hwnd,id_TargetBulk,buf);
  sprintf(buf,"%.3f",Main.WaveLength);
  SetDlgItemText(hwnd,id_WaveLength,buf);
  sprintf(buf,"%s",Main.User);
  SetDlgItemText(hwnd,id_Scientist,buf);
  sprintf(buf,"%d",Main.Current);
  SetDlgItemText(hwnd,id_BeamCurrent,buf);
  sprintf(buf,"%d",Main.Voltage);
  SetDlgItemText(hwnd,id_BeamVoltage,buf);
  GetHKL(Main.Reflection,buf);
  SetDlgItemText(hwnd,id_Reflection,buf);
  GetHKL(Main.Orientation,buf);
  SetDlgItemText(hwnd,id_Orientation,buf);
  SetDlgItemText(hwnd,id_Text,Main.Comment);
  return TRUE;
};

BOOL TMeasurementParam::CanClose(void)
{
  char buf[MaxString];
  BOOL fl;

  GetDlgItemText(GetHandle(),id_TargetName,buf,MaxString);
  strcpy(Main.Target,buf);
  GetDlgItemText(GetHandle(),id_TargetBulk,buf,MaxString);
  strcpy(Main.TargetBulk,buf);
  GetDlgItemText(GetHandle(),id_Reflection,buf,MaxString);
  SetHKL(Main.Reflection,buf);
  GetDlgItemText(GetHandle(),id_Orientation,buf,MaxString);
  SetHKL(Main.Orientation,buf);
  GetDlgItemText(GetHandle(),id_WaveLength,buf,MaxString);
  Main.WaveLength = atof(buf);
  GetDlgItemText(GetHandle(),id_Scientist,buf,MaxString);
  strcpy(Main.User,buf);
  Main.Current = GetDlgItemInt(GetHandle(),id_BeamCurrent,&fl,FALSE);
  Main.Voltage = GetDlgItemInt(GetHandle(),id_BeamVoltage,&fl,FALSE);
  SetStaticInfo("");
  GetDlgItemText(GetHandle(),id_Text,Main.Comment,2*MaxString);
  return TRUE;
};

//************ Dialog Manuelle Justage *****************************************
//************ Steuerung des Probentellers ber den Winkel *********************
#ifdef GermanVersion
TAngleControl::TAngleControl(void):TModalDlg("AngleControl")
#else
TAngleControl::TAngleControl(void):TModalDlg("AngleControlEng")
#endif
{
  bMoveActive = FALSE; // Alle Motoren befinden sich im Stillstand
  AskTime     = 100;   // Zeit fr den Timer (msec)
  bLongMove   = FALSE; // Fahrbetrieb "aus" bei Initialisierung
  bMeasureHwb = FALSE; // Halbwertsbreite noch nicht gemessen
  bStepMode   = TRUE;  // Schrittbetrieb "ein" bei Initialisierung
  // Liste der Geschwindigkeiten: Lnge=Anzahl der Motoren
  MoveSpeed   = new float [mlGetAxisNumber()];
};

BOOL TAngleControl::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
{
  int cnt;

  TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam); // Konstruktor von der Basisklasse ausfhren
  nMotor = mlGetAxis();  // nMotor = Anzahl der Motoren bzw. Achsen
  Sensor = lpDList->DP(); // Pointer auf den akt. Sensor
  BarHandle = GetDlgItem(hwnd,id_Bar); // Handle auf die Scrollbar
  // Handle auf die Motorenliste, nicht zu verwechseln mit der Motorenliste
  // MPlist, hier geht es um die Liste die in der Combobox erscheint
  // Ist also nur Dialogbezogen
  hMotorList = GetDlgItem(hwnd,id_ChooseMotor);
  // Eingabetextfeld fr Schrittbetrieb einblenden (d.h.Eingabe ist mglich)
  EnableWindow(GetDlgItem(hwnd,id_AngleWidth),bStepMode);
  // Eingabetextfeld fr Geschwindigkeitsangabe eingrauen (keine Eingabe mglich)
  EnableWindow(GetDlgItem(hwnd,id_SpeedValue),!bStepMode);
  if(!mlIsAxisValid(Omega))   // Wenn Omega nicht da,
  {
    // dann blende die Schnellauswahl-Schaltelemente Beugung fein
    // bzw. Omega(eng.) und "Halbwertsbreite messen" aus(eingrauen)
    EnableWindow(GetDlgItem(hwnd,cm_SetFine),FALSE);
    EnableWindow(GetDlgItem(hwnd,cm_MeasureHWB),FALSE);
  }
  if(!mlIsAxisValid(Psi))  // Wenn Psi nicht da,
    // dann Schnellauswahlschalter Tilt ausblenden (eingrauen)
    EnableWindow(GetDlgItem(hwnd,cm_SetTilt),FALSE);
  if(!Steering.GetMacroById(InquireHwb)) // Wenn das Makro InquireHWB nicht
    //verfgbar, dann "Halbwertsbreite messen" ausblenden (eingrauen)
    EnableWindow(GetDlgItem(hwnd,cm_MeasureHWB),FALSE);
  if(!mlIsAxisValid(Collimator)) // Wenn Achse Collimator nicht verfgbar ist,
    // dann blende "Collimator" aus der Schnellauswahl aus (eingrauen)
    EnableWindow(GetDlgItem(hwnd,cm_SetCollimator),FALSE);
  // Den Checkbutton "Fahren" als nichtgedrckt(Schalter aus) kennzeichnen
  CheckDlgButton(hwnd,id_LongMoveMode,!bStepMode);
  cnt = 0;
  while(cnt < mlGetAxisNumber()) // alle Achsen durchgehen
  {
    mlSetAxis(cnt++); // alle Achsen durchgehen und jede Achse in die
    ComboBox_AddString(hMotorList,mGetAxisName()); // Motorenliste eintragen
  }
  // Timer setzen fr Multitasking bei Windows 3.1 (unechtes MT)
  SetTimer(hwnd,TimerIdInformation,AskTime,NULL);
  // Sichern der Motor-Einstellungen
  for(cnt = 0; cnt < mlGetAxisNumber(); cnt++)
  {
    mlSetAxis(cnt);
    mPushSettings();
    //Geschwindigkeiten fr die einzelnen Motoren eintragen
    MoveSpeed[cnt] = mGetValue(Speed);
  }
  mlSetAxis(nMotor);
  FORWARD_WM_COMMAND(hwnd,cm_MotorInit,hwndCtl,0,SendMessage);
  FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
  bMoveActive = TRUE;
  SetTimer(hwnd,TimerIdInformation,AskTime,NULL);
  return TRUE;
};

// Wurde vom Programierer hchstwahrscheinlich fr Testzwecke verwendet

#define TestCall KillTimer(GetHandle(),TimerIdInformation); \
  if(Motor->IsMoveFinish())                                 \
  {                                                         \
    if(!Motor->GetAngle(1))                                 \
    {                                                       \
      SetCursor(LoadCursor(NULL,IDC_WAIT));                 \
      SetTimer(GetHandle(),TimerIdInformation,AskTime,NULL);\
      return TRUE;                                          \
    }                                                       \
    bLongMove = FALSE;                                      \
    Motor->dAngleNew = Motor->dAngle;                       \
    sprintf(buf,Motor->pOFmt(),Motor->dAngleNew);           \
    SetDlgItemText(GetHandle(),id_NewAngle,(LPSTR)buf);     \
    sprintf(buf,Motor->pOFmt(),Motor->dAngle);              \
    SetDlgItemText(GetHandle(),id_Angle,(LPSTR)buf);        \
    SetScrollPos(BarHandle,SB_CTL,GetBarPos(),TRUE);        \
    bMoveActive = FALSE;                                    \
    SetCursor(LoadCursor(NULL,IDC_ARROW));                  \
  }                                                         \
  else                                                      \
  {                                                         \
    if(bLongMove)                                           \
    {                                                       \
      Motor->GetAngle(0);                                   \
      sprintf(buf,Motor->pOFmt(),Motor->dAngle);            \
      SetDlgItemText(GetHandle(),id_Angle,(LPSTR)buf);      \
      SetScrollPos(BarHandle,SB_CTL,GetBarPos(),TRUE);      \
    }                                                       \
    SetCursor(LoadCursor(NULL,IDC_WAIT));                   \
  }                                                         \

void TAngleControl::Dlg_OnTimer(HWND hwnd,UINT id)
{
  char   buf[MaxString];
  double dDistance;

  switch(id)
  {
    case TimerIdInformation:
    KillTimer(hwnd,TimerIdInformation);
    if(mIsMoveFinish())
    {
      if(!mGetDistance(dDistance))
      {
        SetCursor(LoadCursor(NULL,IDC_WAIT));
        SetTimer(hwnd,TimerIdInformation,AskTime,NULL);
        return;
      }
      bLongMove = FALSE;
      sprintf(buf,mGetDF(),dDistance);
      SetDlgItemText(hwnd,id_NewAngle,(LPSTR)buf);
      SetDlgItemText(hwnd,id_Angle,(LPSTR)buf);
      SetScrollPos(BarHandle,SB_CTL,GetBarPos(),TRUE);
      bMoveActive = FALSE;
      SetFocus(BarHandle);
      SetCursor(LoadCursor(NULL,IDC_ARROW));
    }
    else
    {
      if(bLongMove)
      {
        sprintf(buf,mGetDF(),mGetDistanceProcess());
        SetDlgItemText(hwnd,id_Angle,buf);
      }
      SetCursor(LoadCursor(NULL,IDC_WAIT));
      SetTimer(hwnd,TimerIdInformation,AskTime,NULL);
    }
  }
};

void TAngleControl::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
{
  static HWND hDlgItem;
  long   varl = 0;
  int    idx;
  char   buf[MaxString];

  switch(id)
  {
    case cm_ParamSet:
    // Wird mit relativen Positionen gearbeitet ?
    if(mIsDistanceRelative())
      // Wenn ja, dann aktiviere Schalter "Relative Null aufheben" (ausgrauen)
      EnableWindow(GetDlgItem(hwnd,cm_CancelRelativeZero),TRUE);
    else
      // Ansonsten wird Schalter eingegraut
      EnableWindow(GetDlgItem(hwnd,cm_CancelRelativeZero),FALSE);
    sprintf(buf,mGetDF(),mGetValue(Distance));
    // Position bei Textfeld "Winkel:" unter der Scrollbar eintragen
    SetDlgItemText(hwnd,id_Angle,(LPSTR)buf);
    // Textfeld "Neuer Winkel" bekommt erstmal den selben Wert
    SetDlgItemText(hwnd,id_NewAngle,(LPSTR)buf);
    // Aktuellen Antrieb in der Combobox anzeigen
    ComboBox_SelectString(hMotorList,0,mGetAxisName());
    // Einheit vom aktuellen Antrieb hinter "Neuer Winkel" eintragen
    SetDlgItemText(hwnd,id_Unit,mGetAxisUnit());
    // Einheit vom akt. Antrieb hinter Schrittbetrieb eintragen
    SetDlgItemText(hwnd,id_StepUnit,mGetAxisUnit());
    // Initialisieren des Motor-Scroll-Bars
    SetScrollRange(BarHandle,SB_CTL,GetBarEgde(LEFT),GetBarEgde(RIGHT),TRUE);
    // Focus auf die Scrollbar setzen
    SetFocus(BarHandle);
    break;

    case cm_SetAngleZero: // Relative Null setzen
    // Wenn Motor aktiv, dann gleich wieder raus
    if(bMoveActive)
      break;
    // Ansonsten rel. Null setzen
    mSetRelativeZero(YES,mGetValue(Distance));
    // entsprechend die Schalter ein- bzw. ausblenden
    if(mIsDistanceRelative())
      EnableWindow(GetDlgItem(hwnd,cm_CancelRelativeZero),TRUE);
    else
      EnableWindow(GetDlgItem(hwnd,cm_CancelRelativeZero),FALSE);
    // Motor aktivieren
    bMoveActive = bLongMove = TRUE;
    // Motoreinstellungen sichern
    mPushSettings();
    SetTimer(hwnd,TimerIdInformation,AskTime,NULL);
    SetFocus(BarHandle);
    break;

    case cm_CancelRelativeZero: // Relative Null aufheben
    // Wenn der Motor in Benutzung, dann gleich abbrechen
    if(bMoveActive)
      break;
    // relative Null fr akt. Motor aufheben
    mSetRelativeZero(NO,0.0);
    // Motor aktivieren
    bMoveActive = bLongMove = TRUE;
    SetTimer(hwnd,TimerIdInformation,AskTime,NULL);
    // Schalter "Relative Null aufheben" ausblenden
    EnableWindow(GetDlgItem(hwnd,cm_CancelRelativeZero),FALSE);
    SetFocus(BarHandle);
    break;

    case cm_MotorInit:
    // Fr Moduswechsel, Shortcuts und Motorwechsel
    // Textfeld fr Schrittbetrieb ausgrauen oder auch nicht ("bStepMode")
    EnableWindow(GetDlgItem(hwnd,id_AngleWidth),bStepMode);
    // Wechselseitiger Ausschlu der Textfelder von Schrittbetrieb und
    // Fahrbetrieb, je nachdem wie die bStepMode gesetzt ist
    EnableWindow(GetDlgItem(hwnd,id_SpeedValue),!bStepMode);
    // Checkbutton entsprechend von bStepMode setzen
    CheckDlgButton(hwnd,id_StepMode,bStepMode);
    if(bStepMode)
      // Wenn Schrittbetrieb, dann Geschwindigkeit auf 10000 (akt. Motor)
      mSetValue(Speed,10000.0);
    else
      // Ansonsten setze den Speed so wie er in der "MoveSpeed"-Liste steht
      mSetValue(Speed,MoveSpeed[nMotor]);
    sprintf(buf,mGetSF(),mGetValue(Width));
    // Schrittweite und Geschwindigkeit in den Textfelder eintragen
    SetDlgItemText(hwnd,id_AngleWidth,(LPSTR)buf);
    sprintf(buf,mGetDF(),(float)mGetValue(Speed));
    SetDlgItemText(hwnd,id_SpeedValue,(LPSTR)buf);
    // Aktiviere den Motor
    mActivateDrive();
    if(bManualMovesCorrected)
      mSetCorrectionState(ON);
//####################################################################
// Fr berprfung der Kalibrierungskurven Correction aktivieren
//####################################################################
    // Initialisieren des Positions-Eingabefenster's
    bMoveActive = TRUE;
#ifdef GermanVersion
    if(mIsCalibrated())
      sprintf(buf,"Manuelle Justage");
    else
      sprintf(buf,"Manuelle Justage : Kein gltiger Referenzpunktlauf");
#else
    if(mIsCalibrated())
      sprintf(buf,"Manual Adjustment");
    else
      sprintf(buf,"Manual Adjustment : No valid Reference Point");
#endif
    SetWindowText(hwnd,(LPCSTR)buf);
    SetTimer(hwnd,TimerIdInformation,AskTime,NULL);
    break;

    case id_StepMode: // Schrittbetrieb aktivieren
    // Wenn Motor aktiviert, dann gleich wieder raus
    if(bMoveActive)
      break;
    // wenn noch nicht in Schrittbetrieb
    if(!bStepMode)
    {
      bStepMode = TRUE;  // Flag setzen
      // cm_MotorInit auslsen
      SendMessage(hwnd,WM_COMMAND,cm_MotorInit,0);
      SetFocus(BarHandle);
    }
    else
    {
      // ansonsten Focus auf Eingabefeld setzen
      SetFocus(GetDlgItem(hwnd,id_AngleWidth));
      hDlgItem = GetDlgItem(hwnd,id_AngleWidth);
    }
    break;

    case id_LongMoveMode: // Fahrbetrieb aktivieren
    // wenn in Schrittbetrieb
    if(bStepMode)
    {
      bStepMode = FALSE; // dann Flag auf false setzen
      // cm_MotorInit ausfhren
      FORWARD_WM_COMMAND(hwnd,cm_MotorInit,0,0,SendMessage);
      SetFocus(BarHandle);
    }
    else
    {
      // ansonsten Focus auf Eingabefeld setzen
      hDlgItem = GetDlgItem(hwnd,id_SpeedValue);
      ReplyMessage(varl);
      SetFocus(GetDlgItem(hwnd,id_SpeedValue));
    }
    break;

    case cm_MeasureHWB: // Halbwertsbreite messen
    if(bMeasureHwb)
    {
      // Messung abbrechen
      bMeasureHwb = FALSE;
      Steering.ToggleInterrupt();
#ifdef GermanVersion
      SetWindowText(GetDlgItem(hwnd,cm_MeasureHWB),"&Halbwertsbreite messen");
#else
      SetWindowText(GetDlgItem(hwnd,cm_MeasureHWB),"Measure &Halfwidth");
#endif
      mlSetAxis(nMotor);
      SendMessage(hwnd,WM_COMMAND,cm_MotorInit,0);
      SendMessage(hwnd,WM_COMMAND,cm_ParamSet,0);
      bMoveActive = TRUE;
      SetTimer(hwnd,TimerIdInformation,AskTime,NULL);
      break;
    }
    if(bMoveActive)
      break;
    bMeasureHwb = TRUE;
    bMoveActive = TRUE;
    Steering.Reset();
    Steering.StartUp(hwnd,nMotor,Sensor->GetId());
    Steering.Visualising(1,0,0,0,0,0);
#ifdef GermanVersion
    SetWindowText(GetDlgItem(hwnd,cm_MeasureHWB),"&Messung abbrechen");
#else
    SetWindowText(GetDlgItem(hwnd,cm_MeasureHWB),"Skip &Measurement");
#endif
    // Makro Inquire Hwb ausfhren
    Steering.StartMacroExecution(Steering.GetMacroById(InquireHwb),hwnd);
    break;

    case cm_CounterSet:
    Sensor->UpdateDisplay();
    Steering.DeviceRequest();
    break;

    case cm_SteeringReady:
    mlSetAxis(nMotor);
    FORWARD_WM_COMMAND(hwnd,cm_MotorInit,0,0,SendMessage);
    FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
    bMoveActive = TRUE;
    SetTimer(hwnd,TimerIdInformation,AskTime,NULL);
    MessageBeep(0);
    bMeasureHwb = FALSE;
#ifdef GermanVersion
    sprintf(buf,"HWB = %.2f Sekunden",Steering.fHWB);
    SetInfo(buf);
    SetWindowText(GetDlgItem(hwnd,cm_MeasureHWB),"&Halbwertsbreite messen");
#else
    sprintf(buf,"HWB = %.2f arcsec",Steering.fHWB);
    SetInfo(buf);
    SetWindowText(GetDlgItem(hwnd,cm_MeasureHWB),"Measure &Halfwidth");
#endif
    break;

    case id_ChooseMotor: // Motor aus der Combobox auswhlen
    switch(codeNotify)
    {
      case CBN_SELCHANGE:
      idx = ComboBox_GetCurSel(hMotorList);
      if((nMotor != idx) && (idx != CB_ERR))
      {
        nMotor = idx;
        mlSetAxis(nMotor);
        FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
        FORWARD_WM_COMMAND(hwnd,cm_MotorInit,0,0,PostMessage);
      }
    }
    break;

    case cm_RotateMotor: // Die Motoren in der Combobox rotieren
    // der Schalter ist aber ausgeblendet im Dialog
    if(bMoveActive)
      break;
    if(!hDlgItem)
      break;
    mlSetAxis(++nMotor); // einen Motor weiterschalten
    nMotor = mlGetAxis(); // merken, welcher aktiv ist
    FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
    FORWARD_WM_COMMAND(hwnd,cm_MotorInit,0,0,PostMessage);
    break;

    case cm_SetFine: // in Schnellauswahl "Beugung Fein" auswhlen
    if(bMoveActive)
      break;
    // Welche ID hat "Beugung Fein" ? Die Achse mit dieser ID aktivieren
    mlSetAxis(mlGetIdByName(Omega));
    nMotor = mlGetAxis(); // merken welcher Antrieb aktiviert ist
    FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
    FORWARD_WM_COMMAND(hwnd,cm_MotorInit,0,0,PostMessage);
    break;

    case cm_SetTilt: // Tilt in Schnellauswahl auswhlen
    if(bMoveActive)
      break;
    // Analog wie oben
    mlSetAxis(mlGetIdByName(Psi));
    nMotor = mlGetAxis();
    FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
    FORWARD_WM_COMMAND(hwnd,cm_MotorInit,0,0,PostMessage);
    break;

    case cm_SetCollimator: // Kollimator in Schnellauswahl auswhlen
    if(bMoveActive)
      break;
    // analog wie oben
    mlSetAxis(mlGetIdByName(Collimator));
    nMotor = mlGetAxis();
    FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
    FORWARD_WM_COMMAND(hwnd,cm_MotorInit,0,0,PostMessage);
    break;

    case id_AngleWidth:
    hDlgItem = GetDlgItem(hwnd,id_AngleWidth);
    break;

    case id_SpeedValue:
    hDlgItem = GetDlgItem(hwnd,id_SpeedValue);
    break;

    case id_NewAngle:
    hDlgItem = GetDlgItem(hwnd,id_NewAngle);
    break;

    case IDOK:
    if(!hDlgItem)
    {
      TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
      break;
    }
    // Der Nutzer hat mit Return eine neue Position, eine neue Geschwindigkeit
    // oder eine neue Schrittweite eingegeben
    for(;;)
    {
      if(hDlgItem == GetDlgItem(hwnd,id_AngleWidth))
      {
        GetDlgItemText(hwnd,id_AngleWidth,(LPSTR)buf,10);
        mSetValue(Width,atof(buf));
        sprintf(buf,mGetSF(),mGetValue(Width));
        SetDlgItemText(hwnd,id_AngleWidth,(LPSTR)buf);
        SetScrollRange(BarHandle,SB_CTL,GetBarEgde(LEFT),GetBarEgde(RIGHT),TRUE);
        SetScrollPos(BarHandle,SB_CTL,GetBarPos(),TRUE);
        break;
      }
      if(hDlgItem == GetDlgItem(hwnd,id_NewAngle))
      {
        if(!bMoveActive)
        {
          GetDlgItemText(hwnd,id_NewAngle,(LPSTR)buf,10);
          bMoveActive = TRUE;
          bLongMove = TRUE;
          mMoveToDistance(atof(buf));
          FORWARD_WM_COMMAND(hwnd,cm_MoveButton,0,0,PostMessage);
        }
        break;
      }
      if(hDlgItem == GetDlgItem(hwnd,id_SpeedValue))
      {
        GetDlgItemText(hwnd,id_SpeedValue,(LPSTR)buf,10);
        mSetValue(Speed,atof(buf));
        MoveSpeed[nMotor] = mGetValue(Speed);
        sprintf(buf,mGetSF(),(float)MoveSpeed[nMotor]);
        SetDlgItemText(hwnd,id_SpeedValue,(LPSTR)buf);
        break;
      }
    }
    hDlgItem = NULL;
    SetFocus(BarHandle);
    break;

    case cm_MoveButton:
    bMoveActive = TRUE;
    SetCursor(LoadCursor(NULL,IDC_WAIT));
    SetTimer(hwnd,TimerIdInformation,AskTime,NULL);
    break;

    default:
    TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
  }
};

void TAngleControl::Interrupt(void)
{
  mStopDrive(TRUE);
  DelayTime(5);
};

#pragma argsused
void TAngleControl::Dlg_OnHScrollBar(HWND hwnd,HWND hwndCtl,UINT code,int pos)
{
  if(bMeasureHwb)
    return;
  switch(code)
  {
    case SB_LINEUP:
    if(bMoveActive)
      return;
    if(bStepMode)
      mMoveToDistance(mGetValue(Distance) - mGetValue(Width));
    else
    {
      mMoveToDistance(mGetValue(MinDistance));
      bLongMove = TRUE;
    }
    FORWARD_WM_COMMAND(hwnd,cm_MoveButton,0,0,SendMessage);
    break;

    case SB_LINEDOWN:
    if(bMoveActive)
      return;
    if(bStepMode)
      mMoveToDistance(mGetValue(Distance) + mGetValue(Width));
    else
    {
      mMoveToDistance(mGetValue(MaxDistance));
      bLongMove = TRUE;
    }
    FORWARD_WM_COMMAND(hwnd,cm_MoveButton,0,0,SendMessage);
    break;

    case SB_ENDSCROLL:
    // Bewegung stoppen, wenn lnger gefahren wurde
    if(bLongMove)
      Interrupt();
    break;

    case SB_PAGEUP: case SB_PAGEDOWN:
    break;
  }
};

int TAngleControl::GetBarEgde(int side)
{
  long steps;
  int  ret;

  if(side == LEFT)
  {
    steps = (long)((mGetValue(MaxDistance) - mGetValue(MinDistance)) / mGetValue(Width));
    BarFactor = (int)(steps / 20000l)+1;
    ret = (int)(mGetValue(MinDistance) / (mGetValue(Width) * BarFactor));
  }
  else
  {
    ret = (int)(mGetValue(MaxDistance) / (mGetValue(Width) * BarFactor));
  }
  return ret;
};

int TAngleControl::GetBarPos()
{
  int ret;

  ret = (int)(mGetValue(Distance) / (mGetValue(Width) * BarFactor));
  return ret;
};

BOOL TAngleControl::LeaveDialog(void)
{
  int cnt;

  cnt = KillTimer(GetHandle(),TimerIdInformation);
  if(Sensor->GetId() != dlGetIdByName(PsdDevice))
  {
    Sensor->MeasureStop();
    Sensor->PopSettings();
    Sensor->MeasureStart();
  }
  mStopDrive(TRUE);
  for(cnt = 0; cnt < mlGetAxisNumber(); cnt++)
  {
    mlSetAxis(cnt);
    mPopSettings(ThisPosition);
    mSetCorrectionState(OFF);
  }
  mlSetAxis(nMotor);
  return TRUE;
};


// __LastLine__




